/* Colors.cpp defines non-trivial Color operations.
 * ...
 */
 
#include "Colors.h"
#include <cstdlib>   // exit()
using namespace std;

string toValid(const string& aString);
string toValid(const string& aString)
{
  string result = aString;
  
  if ( !result.empty() && islower(result[0]) )
    result[0] = toupper(result[0]);
    
  for (int i = 1; i < aString.size(); i++)
    if ( isupper(aString[i]) )
      result[i] = tolower(aString[i]);
      
  return result;
}

bool validColor(const string& colorName);
bool validColor(const string& colorName)
{
 string copy = toValid(colorName);
 
 if(copy == "Red" || copy == "Orange" 
       || copy == "Yellow" || copy == "Green"
       || copy == "Blue" || copy == "Indigo"
       || copy == "Violet")
    return true;
  else
    return false;
}


// ---- string-to-Color constructor
Color::Color(const string& colorName)
{
  if ( validColor(colorName) )
     myName = colorName;
  else
  {
     cerr << "\n*** Color(name): "
          << colorName << endl;
     exit(1);
  }
}

// ---- string-to-Color converter
Color* Color::fromString(const string& colorName)
{
  string copy = toValid(colorName);
  
  if (copy == "Red")
    return new Red();
  else if (copy == "Orange")
    return new Orange();
  else if (copy == "Yellow")
    return new Yellow();
  else if (copy == "Green")
    return new Green();
  else if (copy == "Blue")
    return new Blue();
  else if (copy == "Indigo")
    return new Indigo();
  else if (copy == "Violet")
    return new Violet();
  else
  {
    cerr << "\n*** Color::fromString(): " << colorName
         << " is not recognized." << endl;
    return 0;
  }
}


// ---- Input Function -----------------
istream& operator>>(istream& in, Color*& colorPtr)
{
  string colorString;
  in >> colorString;
  
  if ( validColor(colorString) )
    colorPtr = Color::fromString(colorString);
  else
  {
    cerr << "\n*** operator<<(): unsupported color "
         << colorString << " received." << endl;
    in.setstate(ios::failbit);
  }
  
  return in;
}

// ---- Output Function -------------------
ostream& operator<<(ostream& out, const Color*& colorPtr)
{
  if (colorPtr != 0)
     out << colorPtr->asString();
  else
     out << "*** NULL HANDLE ***";
     
  return out;
}
